;***** EDTABLE.LSP *****;
;
;++Last Update 05/28/93++
  
;{{/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\}}
;{{{{ Send Comments or Questions (or Donations!) }}}}
;{{{{                                            }}}}
;{{{{ To:                                        }}}}
;{{{{     Owen Wengerd                           }}}}
;{{{{     P.O. Box 84                            }}}}
;{{{{     Fredericksburg, OH  44627              }}}}
;{{{{     (216) 695-5903                         }}}}
;{{{{     71324,3252 (Compu-Serve ID)            }}}}
;{{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}}


(defun errexit (s)
  (princ "\nError:  ")
  (princ s)
  (restore)
)

(defun edtablex ()
  (setq  errexit   nil
         edtablex  nil
         savetable nil
         gettable  nil
         EDTABLE   nil
  )
  (setvar "EXPERT" (nth 1 oldvar))
  (setvar "CMDECHO" (car oldvar))
  (setq *error* olderr)
  (princ)
)

(defun gettable (/ fh t1 t2 t3)
  (if
    (setq table
      (getfiled
        "Select Table To Edit:"
        (strcat (if *LISPPATH *LISPPATH "") "*")
        "tbl"
        258
      )
    )
    (progn
      (setq fh (open table "r"))
      (setq t2 nil)
      (while
        (setq t1 (read-line fh))
        (setq t2 (cons t1 t2))
      )
      (close fh)
      (setq t2 (reverse t2))
      (setq rows (list (atoi (car t2)) (atoi (cadr t2))))
      (setq columns (list (atoi (nth 2 t2)) (atoi (nth 3 t2))))
      (setq t2 (cddddr t2))
      (setq t3 (+ (car columns) (abs (cadr columns))))
      (setq center nil)
      (repeat t3
        (progn
          (setq center (cons (car t2) center))
          (setq t2 (cdr t2))
        )
      )
      (setq center (reverse center))
      (setq width nil)
      (repeat t3
        (progn
          (setq width (cons (atof (car t2)) width))
          (setq t2 (cdr t2))
        )
      )
      (setq width (reverse width))
      (setq t3 (+ (car rows) (abs (cadr rows))))
      (setq height nil)
      (repeat t3
        (progn
          (setq height (cons (atof (car t2)) height))
          (setq t2 (cdr t2))
        )
      )
      (setq height (reverse height))
      (setq textheight (atof (car t2)))
      (setq upright (/= "nil" (cadr t2)))
      (setq rowbyrow (/= "nil" (caddr t2)))
      (setq contents (cdddr t2))
      (setq table table)
    )
    (setq table nil)
  )
)

(defun savetable (table / fh t3)
  (setq fh (open table "w"))
  (setq table
    (append rows columns center width height
           (list textheight upright rowbyrow)
           contents
    )
  )
  (setq t3 0)
  (while
    (< t3 (length table))
    (princ (nth t3 table) fh)
    (princ "\n" fh)
    (setq t3 (1+ t3))
  )
  (close fh)
)


(defun EDTABLE (/ table rows columns center width height textheight upright 
        rowbyrow contents t1 t2 t3 t4 ct ct1 sc oldvar olderr restore)

  (setq oldvar
    (list
      (getvar "CMDECHO")
      (getvar "EXPERT")
    )
  )
  (setq olderr  *error*
        restore edtablex
        *error* errexit
  )
  (setvar "CMDECHO" 0)
  (setvar "EXPERT" 0)
  (terpri)
  (if
    (gettable)
    (progn
      (initget 4)
      (setq t3 rows)
      (setq rows
        (list
          (if
            (setq t4
              (getint
                (strcat
                  "\nHow Many Predefined Rows? <"
                  (itoa (car rows))
                  ">:  "
                )
              )
            )
            t4
            (car rows)
          )
          (if
            (setq t4
              (progn
                (initget 4 ".")
                (getint
                  (strcat
                    "How Many Undefined Rows? <"
                    (if (= -1 (cadr rows)) "variable" (itoa (cadr rows)))
                    ">"
                    (if (= -1 (cadr rows)) "" "/(.)=variable")
                    ":  "
                  )
                )
              )
            )
            (if (= t4 ".") -1 t4)
            (cadr rows)
          )
        )
      )
      (setq ct (+ (car rows) (abs (last rows))))
      (setq t3 (+ (car t3) (abs (last t3))))
      (setq t2 height)
      (setq height nil)
      (setq t1 1)
      (initget 4)
      (repeat
        ct
        (setq height
          (cons
            (if
              (setq t4
                (getreal
                  (strcat
                    "Enter Height of "
                    (if
                      (and (= -1 (last rows)) (= ct t1))
                      "Undefined Rows"
                      (strcat "Row " (rtos t1 2 0))
                    )
                    " <"
                    (rtos
                      (if
                        (<= t1 (length t2))
                        (nth (1- t1) t2)
                        (if height (car height) (last t2))
                      )
                      2
                    )
                    ">: "
                  )
                )
              )
              t4
              (if
                (<= t1 (length t2))
                (nth (1- t1) t2)
                (if height (car height) (last t2))
              )
            )
            height
          )
        )
        (setq t1 (1+ t1))
      )
      (setq height (reverse height))
      (setq t3 (list t3 (+ (car columns) (abs (last columns)))))
      (setq columns
        (list
          (if
            (setq t4
              (progn
                (initget 4)
                (getint
                  (strcat
                    "\nHow Many Predefined Columns? <"
                    (itoa (car columns))
                    ">:  "
                  )
                )
              )
            )
            t4
            (car columns)
          )
          (if
            (setq t4
              (progn
                (initget 4 ".")
                (getint
                  (strcat
                    "How Many Undefined Columns? <"
                    (if (= -1 (cadr columns))
                      "variable"
                      (itoa (cadr columns))
                    )
                    ">"
                    (if (= -1 (cadr columns)) "" "/(.)=variable")
                    ":  "
                  )
                )
              )
            )
            (if (= t4 ".") -1 t4)
            (cadr columns)
          )
        )
      )
      (setq t2 width)
      (setq width nil)
      (setq t1 1)
      (setq ct (+ (car columns) (abs (last columns))))
      (initget 4)
      (repeat
        ct
        (setq width
          (cons
            (if
              (setq t4
                (getreal
                  (strcat
                    "Enter Width of "
                    (if
                      (and (= -1 (last columns)) (= ct t1))
                      "Undefined Columns"
                      (strcat "Column " (rtos t1 2 0))
                    )
                    " <"
                    (rtos
                      (if
                        (<= t1 (length t2))
                        (nth (1- t1) t2)
                        (if width (car width) (last t2))
                      )
                      2
                    )
                    ">: "
                  )
                )
              )
              t4
              (if
                (<= t1 (length t2))
                (nth (1- t1) t2)
                (if width (car width) (last t2))
              )
            )
            width
          )
        )
        (setq t1 (1+ t1))
      )
      (setq width (reverse width))
      (setq t2 center)
      (setq center nil)
      (setq t1 1)
      (repeat
        ct
        (setq center
          (cons
            (if
              (setq t4
                (progn
                  (initget 6 "Left Right Center")
                  (setq t4
                    (if
                      (<= t1 (length t2))
                      (nth (1- t1) t2)
                      (if center (car center) (last t2))
                    )
                  )
                  (getkword
                    (strcat
                      "Specify Justification for "
                      (if
                        (and (= -1 (last columns)) (= ct t1))
                        "Undefined Columns"
                        (strcat "Column " (rtos t1 2 0))
                      )
                      (if (= t4 "L") " (<L>eft/" " (Left/")
                      (if (= t4 "R") "<R>ight/" "Right/")
                      (if (= t4 "C") "<C>enter" "Center")
                      "): "
                    )
                  )
                )
              )
              (strcase (substr t4 1 1))
              (if
                (<= t1 (length t2))
                (nth (1- t1) t2)
                (if center (car center) (last t2))
              )
            )
            center
          )
        )
        (setq t1 (1+ t1))
      )
      (setq center (reverse center))
      (initget 6)
      (setq textheight
        (if
          (setq t4
            (getreal
              (strcat
                "\nEnter Text Height <"
                (rtos textheight 2)
                ">:  "
              )
            )
          )
          t4
          textheight
        )
      )
      (initget 6 "Yes No")
      (if upright (setq t1 "Y") (setq t1 "N"))
      (setq upright
        (if
          (= 0 (car rows))
          (not nil)
          (=
            "Y"
            (if
              (setq t4
                (getkword
                  (strcat
                    "Will Predefined Rows Be at the Top of the Table? ("
                    (if (= t1 "Y") "<Y>/N" "Y/<N>")
                    "): "
                  )
                )
              )
              (strcase (substr t4 1 1))
              (if (= t1 "Y") "Y" "N")
            )
          )
        )
      )
      (initget 6 "Column Row")
      (setq n rowbyrow)
      (setq rowbyrow
        (if
          (or
            (and (/= -1 (last columns)) (= 1 (apply '+ columns)))
            (and (/= -1 (last rows)) (= 1 (apply '+ rows)))
          )
          nil
          (=
            "R"
            (if
              (setq t4
                (getkword
                  (strcat
                    "Enter Variable Cells Row by row or Column by column? ("
                    (if rowbyrow "<R>/C" "R/<C>")
                    "):  "
                  )
                )
              )
              (strcase (substr t4 1 1))
              (if rowbyrow "R" "C")
            )
          )
        )
      )
      (if rowbyrow (setq t3 (reverse t3)))
      (if
        (/= n rowbyrow)
        (progn
          (setq sc nil)
          (setq t1 0)
          (repeat (cadr t3)
            (setq t2 0)
            (repeat (car t3)
              (setq sc
                (cons
                  (nth
                   (+ t1 (* t2 (cadr t3)))
                    contents
                  )
                  sc
                )
              )
              (setq t2 (1+ t2))
            )
            (setq t1 (1+ t1))
          )
          (setq sc (reverse sc))
        )
        (setq sc contents)
      )
      (setq contents nil)
      (terpri)
      (set 
        (if rowbyrow 'ct 'ct1)
        (+ (car columns) (abs (last columns)))
      )
      (set
        (if rowbyrow 'ct1 'ct)
        (+ (car rows) (abs (last rows)))
      )
      (setq t1 1)
      (initget 0)
      (repeat
        ct1
        (princ
          (if
            (and (= ct1 t1) (= -1 (last (if rowbyrow rows columns))))
            (strcat
              "\nUndefined "
              (if rowbyrow "Rows:\n" "Columns:\n")
            )
            (strcat
              (if rowbyrow "\nRow " "\nColumn ")
              (rtos t1 2 0)
              ":\n"
            )
          )
        )
        (setq t2 1)
        (repeat
          ct
          (setq contents
            (cons
              (if
                (/= ""
                  (setq t4
                    (getstring ct
                      (strcat
                        "  Enter Contents of "
                        (if
                          (and
                            (= -1 (last (if rowbyrow columns rows)))
                            (= ct t2)
                          )
                          (strcat
                            "Undefined "
                            (if rowbyrow "Columns" "Rows")
                          )
                          (strcat
                            (if rowbyrow "Column " "Row ")
                            (rtos t2 2 0)
                          )
                        )
                        " <"
                        (if
                          (and
                            (<= t1 (cadr t3))
                            (<= t2 (car t3))
                            (/=
                              ""
                              (setq t4
                                (nth (+ (* (car t3) (1- t1)) (1- t2)) sc)
                              )
                            )
                          )
                          t4
                          (progn (setq t4 "") "variable")
                        )
                        ">"
                        (if (/= "" t4) "/(.)=variable" "")
                        ": "
                      )
                    )
                  )
                )
                (if (= t4 ".") "" t4)
                (if
                  (and
                    (<= t1 (cadr t3))
                    (<= t2 (car t3))
                  )
                  (nth (+ (* (car t3) (1- t1)) (1- t2)) sc)
                  ""
                )
              )
              contents
            )
          )
          (setq t2 (1+ t2))
        )
        (setq t1 (1+ t1))
      )
      (setq contents (reverse contents))
      (if
        (setq table (getfiled "Save Table As:" table "tbl" 259))
        (savetable table)
      )
    )
  )
  (restore)
)

(EDTABLE)
